/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.31 from the
 * contents of Event.xs. Do not edit this file, edit Event.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Event.xs"
/* -*- C -*- sometimes */

#define MIN_PERL_DEFINE 1

#ifdef __cplusplus
extern "C" {
#endif

#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>

#ifdef __cplusplus
}
#endif

#include "ppport.h"

/* lexical warnings -- waiting for appropriate magic from
   paul.marquess@bt.com */
#if 0
static void Event_warn(const char* pat, ...) {
    dTHX;
    va_list args;
    va_start(args, pat);
    if (!ckWARN_d(WARN_ALL))
	return;
    Perl_vwarner(aTHX_ WARN_ALL, pat, &args);
    va_end(args);
}

#  undef warn
#  define warn Event_warn
#endif

#if 1
#ifdef warn
#  undef warn
#endif
#define warn Event_warn

static void Event_warn(const char* pat, ...) {
    STRLEN n_a;
    dSP;
    SV *msg;
    va_list args;
    /* perl_require_pv("Carp.pm");     Couldn't possibly be unloaded.*/
    va_start(args, pat);
    msg = sv_newmortal();
    sv_vsetpvfn(msg, pat, strlen(pat), &args, Null(SV**), 0, 0);
    va_end(args);
    SvREADONLY_on(msg);
    PUSHMARK(SP);
    XPUSHs(msg);
    PUTBACK;
    perl_call_pv("Carp::carp", G_DISCARD);
}
#endif

#ifdef croak
#  undef croak
#endif
#define croak Event_croak

static void Event_croak(const char* pat, ...) {
    STRLEN n_a;
    dSP;
    SV *msg;
    va_list args;
    /* perl_require_pv("Carp.pm");     Couldn't possibly be unloaded.*/
    va_start(args, pat);
    msg = sv_newmortal();
    sv_vsetpvfn(msg, pat, strlen(pat), &args, Null(SV**), 0, 0);
    va_end(args);
    SvREADONLY_on(msg);
    PUSHMARK(SP);
    XPUSHs(msg);
    PUTBACK;
    perl_call_pv("Carp::croak", G_DISCARD);
    PerlIO_puts(PerlIO_stderr(), "panic: Carp::croak failed\n");
    (void)PerlIO_flush(PerlIO_stderr());
    my_failure_exit();
}

#ifdef WIN32
#   include <fcntl.h>
#endif

#if defined(HAS_POLL)
# include <poll.h>

/*
	Many operating systems claim to support poll yet they
	actually emulate it with select.  c/unix.c supports
	either poll or select but it doesn't know which one to
	use.  Here we try to detect if we have a native poll
	implementation.  If we do, we use it.  Otherwise,
	select is assumed.
*/

# ifndef POLLOUT
#  undef HAS_POLL
# endif
# ifndef POLLWRNORM
#  undef HAS_POLL
# endif
# ifndef POLLWRBAND
#  undef HAS_POLL
# endif
#endif

/* Is time() portable everywhere?  Hope so!  XXX */

static NV fallback_NVtime()
{ return time(0); }

#include "Event.h"

/* The following is for very simplistic memory leak detection. */

#define MAX_MEMORYCOUNT 20
static int MemoryCount[MAX_MEMORYCOUNT];
static void dbg_count_memory(int id, int cnt) {
    assert(id >= 0 && id < MAX_MEMORYCOUNT);
    MemoryCount[id] += cnt;
}

#if EVENT_MEMORY_DEBUG
#  define EvNew(id, ptr, size, type) dbg_count_memory(id,1); New(0,ptr,size,type)
#  define EvFree(id, ptr) STMT_START { dbg_count_memory(id,-1); safefree(ptr); } STMT_END
#else
#  define EvNew(x, ptr, size, type) New(0,ptr,size,type)
#  define EvFree(id, ptr) safefree(ptr)
#endif

static int LoopLevel, ExitLevel;
static int ActiveWatchers=0; /* includes WaACTIVE + queued events */
static int WarnCounter=16; /*XXX nuke */
static SV *DebugLevel;
static SV *Eval;
static pe_event_stats_vtbl Estat;

/* IntervalEpsilon should be equal to the clock's sleep resolution
   (poll or select) times two.  It probably needs to be bigger if you turn
   on lots of debugging?  Can determine this dynamically? XXX */
static NV IntervalEpsilon = 0.0002;
static int TimeoutTooEarly=0;

static struct EventAPI api;
#define NVtime() (*api.NVtime)()

static int pe_sys_fileno(SV *sv, char *context);

static void queueEvent(pe_event *ev);
static void dequeEvent(pe_event *ev);

static void pe_watcher_cancel(pe_watcher *ev);
static void pe_watcher_suspend(pe_watcher *ev);
static void pe_watcher_resume(pe_watcher *ev);
static void pe_watcher_now(pe_watcher *ev);
static void pe_watcher_start(pe_watcher *ev, int repeat);
static void pe_watcher_stop(pe_watcher *ev, int cancel_events);
static char*pe_watcher_on(pe_watcher *wa, int repeat);
static void pe_watcher_off(pe_watcher *wa);

/* The newHVhv in perl seems to mysteriously break in some cases.  Here
   is a simple and safe (but maybe slow) implementation. */

#ifdef newHVhv
# undef newHVhv
#endif
#define newHVhv event_newHVhv

static HV *event_newHVhv(HV *ohv) {
    register HV *hv = newHV();
    register HE *entry;
    hv_iterinit(ohv);		/* NOTE: this resets the iterator */
    while (entry = hv_iternext(ohv)) {
	hv_store(hv, HeKEY(entry), HeKLEN(entry), 
		SvREFCNT_inc(HeVAL(entry)), HeHASH(entry));
    }
    return hv;
}

static void pe_watcher_STORE_FALLBACK(pe_watcher *wa, SV *svkey, SV *nval)
{
    if (!wa->FALLBACK)
	wa->FALLBACK = newHV();
    hv_store_ent(wa->FALLBACK, svkey, SvREFCNT_inc(nval), 0);
}

/***************** STATS */
static int StatsInstalled=0;
static void pe_install_stats(pe_event_stats_vtbl *esvtbl) {
    ++StatsInstalled;
    Copy(esvtbl, &Estat, 1, pe_event_stats_vtbl);
    Estat.on=0;
}
static void pe_collect_stats(int yes) {
    if (!StatsInstalled)
	croak("collect_stats: no event statistics are available");
    Estat.on = yes;
}

#ifdef HAS_GETTIMEOFDAY
NV null_loops_per_second(int sec)
{
	/*
	  This should be more realistic.  It is used to normalize
	  the benchmark against some theoretical perfect event loop.
	*/
	struct timeval start_tm, done_tm;
	NV elapse;
	unsigned count=0;
	int fds[2];
	if (pipe(fds) != 0) croak("pipe");
	gettimeofday(&start_tm, 0);
	do {
#ifdef HAS_POLL
	  struct pollfd map[2];
	  Zero(map, 2, struct pollfd);
	  map[0].fd = fds[0];
	  map[0].events = POLLIN | POLLOUT;
	  map[0].revents = 0;
	  map[1].fd = fds[1];
	  map[1].events = POLLIN | POLLOUT;
	  map[1].revents = 0;
	  poll(map, 2, 0);
#elif defined(HAS_SELECT)
	  struct timeval null;
	  fd_set rfds, wfds, efds;
	  FD_ZERO(&rfds);
	  FD_ZERO(&wfds);
	  FD_ZERO(&efds);
	  FD_SET(fds[0], &rfds);
	  FD_SET(fds[0], &wfds);
	  FD_SET(fds[1], &rfds);
	  FD_SET(fds[1], &wfds);
	  null.tv_sec = 0;
	  null.tv_usec = 0;
	  select(3,&rfds,&wfds,&efds,&null);
#else
#  error
#endif
	  ++count;
	  gettimeofday(&done_tm, 0);
	  elapse = (done_tm.tv_sec - start_tm.tv_sec +
		    (done_tm.tv_usec - start_tm.tv_usec) / 1000000);
	} while(elapse < sec);
	close(fds[0]);
	close(fds[1]);
return count/sec;
}
#else /* !HAS_GETTIMEOFDAY */
NV null_loops_per_second(int sec)
{ croak("sorry, gettimeofday is not available"); }
#endif


#include "typemap.c"
#include "timeable.c"
#include "hook.c"
#include "ev.c"
#include "watcher.c"
#include "idle.c"
#include "timer.c"
#include "io.c"
#include "unix.c"
#include "var.c"
#include "signal.c"
#include "tied.c"
#include "group.c"
#include "generic.c"
#include "queue.c"

#line 286 "Event.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 430 "Event.c"

XS_EUPXS(XS_Event__add_hook); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__add_hook)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "type, code");
    {
	char *	type = (char *)SvPV_nolen(ST(0))
;
	SV *	code = ST(1)
;
#line 342 "Event.xs"
	pe_add_hook(type, 1, code, 0);
	/* would be nice to return new pe_qcallback* XXX */
#line 446 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__timeout_too_early); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__timeout_too_early)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 348 "Event.xs"
	RETVAL = TimeoutTooEarly;
	TimeoutTooEarly=0;
#line 464 "Event.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__memory_counters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__memory_counters)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 356 "Event.xs"
{
#ifdef EVENT_MEMORY_DEBUG
    int xx;
    for (xx=0; xx < MAX_MEMORYCOUNT; xx++)
	XPUSHs(sv_2mortal(newSViv(MemoryCount[xx])));
#endif
}
#line 488 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__incr_looplevel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__incr_looplevel)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 367 "Event.xs"
     ++LoopLevel;
     ++ExitLevel;
#line 507 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__decr_looplevel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__decr_looplevel)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 373 "Event.xs"
     --LoopLevel;
#line 525 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event_unloop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_unloop)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 378 "Event.xs"
     pe_unloop(items? ST(0) : &PL_sv_undef);
#line 540 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event_unloop_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_unloop_all)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 383 "Event.xs"
     pe_unloop_all(items? ST(0) : &PL_sv_undef);
#line 554 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event_cache_time_api); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_cache_time_api)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	bool	RETVAL;
#line 388 "Event.xs"
	SV **svp = hv_fetch(PL_modglobal, "Time::NVtime", 12, 0);
	if (!svp || !*svp || !SvIOK(*svp))
	    XSRETURN_NO;
	api.NVtime = INT2PTR(NV(*)(), SvIV(*svp));
	XSRETURN_YES;
#line 574 "Event.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_time)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	NV	RETVAL;
	dXSTARG;
#line 398 "Event.xs"
	RETVAL = NVtime();
#line 591 "Event.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event_sleep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_sleep)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tm");
    {
	NV	tm = (NV)SvNV(ST(0))
;
#line 407 "Event.xs"
	pe_sys_sleep(tm);
#line 609 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event_null_loops_per_second); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_null_loops_per_second)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	int	sec = (int)SvIV(ST(0))
;
	NV	RETVAL;
	dXSTARG;

	RETVAL = null_loops_per_second(sec);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event_all_watchers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_all_watchers)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 417 "Event.xs"
	pe_watcher *ev;
	if (!AllWatchers.next)
	  return;
	ev = (pe_watcher*) AllWatchers.next->self;
	while (ev) {
	  XPUSHs(watcher_2sv(ev));
	  ev = (pe_watcher*) ev->all.next->self;
	}
#line 652 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event_all_idle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_all_idle)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 430 "Event.xs"
	pe_watcher *ev;
	if (!Idle.prev)
	  return;
	ev = (pe_watcher*) Idle.prev->self;
	while (ev) {
	  XPUSHs(watcher_2sv(ev));
	  ev = (pe_watcher*) ((pe_idle*)ev)->iring.prev->self;
	}
#line 677 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event_all_running); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_all_running)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 443 "Event.xs"
	int fx;
	for (fx = CurCBFrame; fx >= 0; fx--) {
	  pe_watcher *ev = (CBFrame + fx)->ev->up; /* XXX */
	  XPUSHs(watcher_2sv(ev));
	  if (GIMME_V != G_ARRAY)
	    break;
	}
#line 701 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event_queue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_queue)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 455 "Event.xs"
	pe_watcher *wa;
	pe_event *ev;
#line 719 "Event.c"
#line 458 "Event.xs"
	wa = (pe_watcher*) sv_2watcher(ST(0));
	if (items == 1) {
	    ev = (*wa->vtbl->new_event)(wa);
	    ++ev->hits;
	}
	else if (items == 2) {
	  if (SvNIOK(ST(1))) {
	    ev = (*wa->vtbl->new_event)(wa);
	    ev->hits += SvIV(ST(1));
	  }
	  else {
	    ev = (pe_event*) sv_2event(ST(1));
	    if (ev->up != wa)
	      croak("queue: event doesn't match watcher");
	  }
	}
	queueEvent(ev);
#line 738 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event_one_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_one_event)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 480 "Event.xs"
	NV maxtm = 60;
	if (items == 1) maxtm = SvNV(ST(0));
	RETVAL = safe_one_event(maxtm);
#line 757 "Event.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event__loop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__loop)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 489 "Event.xs"
	pe_check_recovery();
	pe_reentry();
        if (!ActiveWatchers)
          warn("Event: loop without active watchers");
	while (ExitLevel >= LoopLevel && ActiveWatchers) {
	  ENTER;
	  SAVETMPS;
	  one_event(60);
	  FREETMPS;
	  LEAVE;
	}
	LEAVE; /* reentry */
#line 784 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event_queue_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_queue_pending)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 505 "Event.xs"
	pe_queue_pending();
#line 799 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__empty_queue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__empty_queue)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prio");
    {
	int	prio = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 511 "Event.xs"
	pe_check_recovery();
	pe_reentry();
	while (pe_empty_queue(prio));
	LEAVE; /* reentry */
#line 821 "Event.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Event_queue_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event_queue_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prio");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	prio = (int)SvIV(ST(0))
;
#line 520 "Event.xs"
	NV max=0;
	int xx;
	if (prio < 0 || prio >= PE_QUEUES)
	  croak("queue_time(%d) out of domain [0..%d]",
		prio, PE_QUEUES-1);
	for (xx=0; xx <= prio; xx++)
	  if (max < QueueTime[xx]) max = QueueTime[xx];
	XPUSHs(max? sv_2mortal(newSVnv(max)) : &PL_sv_undef);
#line 847 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event__Io_got); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event__Io_got)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 535 "Event.xs"
	XPUSHs(sv_2mortal(events_mask_2sv(((pe_ioevent*)THIS)->got)));
#line 867 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event__Dataful_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event__Dataful_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 542 "Event.xs"
	XPUSHs(((pe_datafulevent*)THIS)->data);
#line 887 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    {
	SV *	ref = ST(0)
;
#line 550 "Event.xs"
{
	pe_event *THIS = (pe_event*) sv_2event(ref);
	if (WaDEBUGx(THIS) >= 3) {
	    STRLEN n_a;
	    warn("Event=0x%x '%s' DESTROY SV=0x%x",
		 THIS, SvPV(THIS->up->desc, n_a),
		 THIS->mysv? SvRV(THIS->mysv) : 0);
	}
	(*THIS->vtbl->dtor)(THIS);
}
#line 914 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Event_mom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event_mom)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 564 "Event.xs"
	if (--WarnCounter >= 0) warn("'mom' renamed to 'w'");
	XPUSHs(watcher_2sv(THIS->up));
#line 934 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event_w); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event_w)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 570 "Event.xs"
	XPUSHs(watcher_2sv(THIS->up));
#line 954 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event_hits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event_hits)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 575 "Event.xs"
	XPUSHs(sv_2mortal(newSViv(THIS->hits)));
#line 974 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Event_prio); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Event_prio)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_event *	THIS = (pe_event *) sv_2event(ST(0))
;
#line 580 "Event.xs"
	XPUSHs(sv_2mortal(newSViv(THIS->prio)));
#line 994 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    {
	SV *	ref = ST(0)
;
#line 588 "Event.xs"
{
	pe_watcher *THIS = (pe_watcher*) sv_2watcher(ref);
	assert(THIS);
	if (THIS->mysv) {
	    THIS->mysv=0;
	    if (WaCANDESTROY(THIS)) /*mysv*/
		(*THIS->vtbl->dtor)(THIS);
	}
}
#line 1020 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_pending)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 601 "Event.xs"
{
    if (GIMME_V == G_ARRAY) {
	pe_event *ev = (pe_event *) THIS->events.prev->self;
	while (ev) {
	    XPUSHs(event_2sv(ev));
	    ev = (pe_event*) ev->peer.prev->self;
	}
    } else {
	XPUSHs(THIS->events.next->self? &PL_sv_yes : &PL_sv_no);
    }
}
#line 1049 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_again); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_again)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 616 "Event.xs"
	pe_watcher_start(THIS, 1);
#line 1067 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 621 "Event.xs"
	pe_watcher_start(THIS, 0);
#line 1084 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_suspend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_suspend)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 626 "Event.xs"
	if (items == 2) {
	    if (sv_true(ST(1)))
		pe_watcher_suspend(THIS);
	    else
		pe_watcher_resume(THIS);
	} else {
	    warn("Ambiguous use of suspend"); /*XXX*/
	    pe_watcher_suspend(THIS);
	    XSRETURN_YES;
	}
#line 1110 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_resume)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 640 "Event.xs"
	warn("Please use $w->suspend(0) instead of resume"); /* DEPRECATED */
	pe_watcher_resume(THIS);
#line 1128 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 646 "Event.xs"
	pe_watcher_stop(THIS, 1);
#line 1145 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_cancel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_cancel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 651 "Event.xs"
	pe_watcher_cancel(THIS);
#line 1162 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_now); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_now)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 656 "Event.xs"
	pe_watcher_now(THIS);
#line 1179 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__Watcher_use_keys); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_use_keys)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 661 "Event.xs"
#line 1195 "Event.c"
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 662 "Event.xs"
	warn("use_keys is deprecated");
#line 1200 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_is_running); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_is_running)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 667 "Event.xs"
	XPUSHs(sv_2mortal(newSViv(THIS->running)));
#line 1220 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_is_active)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 672 "Event.xs"
	PUTBACK;
	XPUSHs(boolSV(WaACTIVE(THIS)));
#line 1241 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_is_suspended); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_is_suspended)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 678 "Event.xs"
	PUTBACK;
	XPUSHs(boolSV(WaSUSPEND(THIS)));
#line 1262 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_is_cancelled); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_is_cancelled)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 684 "Event.xs"
	PUTBACK;
	XPUSHs(boolSV(WaCANCELLED(THIS)));
#line 1283 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_cb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_cb)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 690 "Event.xs"
	PUTBACK;
	_watcher_callback(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1305 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_cbtime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_cbtime)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 697 "Event.xs"
	PUTBACK;
	_watcher_cbtime(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1327 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_desc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_desc)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 704 "Event.xs"
	PUTBACK;
	_watcher_desc(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1349 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_debug)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 711 "Event.xs"
	PUTBACK;
	_watcher_debug(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1371 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_prio); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_prio)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 718 "Event.xs"
	PUTBACK;
	_watcher_priority(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1393 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_reentrant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_reentrant)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 725 "Event.xs"
	PUTBACK;
	_watcher_reentrant(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1415 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_repeat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_repeat)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 732 "Event.xs"
	PUTBACK;
	_watcher_repeat(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1437 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher_max_cb_tm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher_max_cb_tm)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 739 "Event.xs"
	PUTBACK;
	_watcher_max_cb_tm(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1459 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher__Tied_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher__Tied_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 750 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(watcher_2sv(pe_tied_allocate(gv_stashsv(clname, 1),
					    SvRV(temple))));
#line 1483 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher__Tied_hard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher__Tied_hard)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 757 "Event.xs"
	PUTBACK;
	_timeable_hard(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1505 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher__Tied_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher__Tied_at)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 764 "Event.xs"
	PUTBACK;
	_tied_at(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1527 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__Watcher__Tied_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__Watcher__Tied_flags)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 771 "Event.xs"
	PUTBACK;
	_tied_flags(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1549 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__idle_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__idle_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 782 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(watcher_2sv(pe_idle_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 1573 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__idle_hard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__idle_hard)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 789 "Event.xs"
	PUTBACK;
	_timeable_hard(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1595 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__idle_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__idle_max)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 796 "Event.xs"
	PUTBACK;
	_idle_max_interval(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1617 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__idle_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__idle_min)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 803 "Event.xs"
	PUTBACK;
	_idle_min_interval(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1639 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__timer_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__timer_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 814 "Event.xs"
	XPUSHs(watcher_2sv(pe_timer_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 1662 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__timer_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__timer_at)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 820 "Event.xs"
	PUTBACK;
	_timer_at(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1684 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__timer_hard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__timer_hard)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 827 "Event.xs"
	PUTBACK;
	_timeable_hard(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1706 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__timer_interval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__timer_interval)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 834 "Event.xs"
	PUTBACK;
	_timer_interval(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1728 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__io_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__io_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 845 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(watcher_2sv(pe_io_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 1752 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__io_poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__io_poll)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 852 "Event.xs"
	PUTBACK;
	_io_poll(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1774 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__io_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__io_fd)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 859 "Event.xs"
	PUTBACK;
	_io_handle(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1796 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__io_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__io_timeout)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 866 "Event.xs"
	PUTBACK;
	_io_timeout(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1818 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__io_timeout_cb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__io_timeout_cb)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 873 "Event.xs"
	PUTBACK;
	_io_timeout_cb(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1840 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__var_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__var_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 884 "Event.xs"
	XPUSHs(watcher_2sv(pe_var_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 1863 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__var_var); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__var_var)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 890 "Event.xs"
	PUTBACK;
	_var_variable(THIS, items == 2? ST(1) : 0); /* don't mortalcopy!! */
	SPAGAIN;
#line 1885 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__var_poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__var_poll)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 897 "Event.xs"
	PUTBACK;
	_var_events(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1907 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__signal_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__signal_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 908 "Event.xs"
	XPUSHs(watcher_2sv(pe_signal_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 1930 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__signal_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__signal_signal)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 914 "Event.xs"
	PUTBACK;
	_signal_signal(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1952 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__group_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__group_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 925 "Event.xs"
     XPUSHs(watcher_2sv(pe_group_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 1975 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__group_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__group_timeout)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 931 "Event.xs"
	PUTBACK;
	_group_timeout(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 1997 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__group_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__group_add)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 938 "Event.xs"
	PUTBACK;
	_group_add(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2019 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__group_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__group_del)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 945 "Event.xs"
	PUTBACK;
	_group_del(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2041 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__generic_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__generic_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 956 "Event.xs"
     XPUSHs(watcher_2sv(pe_generic_allocate(gv_stashsv(clname, 1),
		SvRV(temple))));
#line 2064 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__generic_source); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__generic_source)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_watcher *	THIS = (pe_watcher *) sv_2watcher(ST(0))
;
#line 962 "Event.xs"
	PUTBACK;
	_generic_source(THIS, items == 2? sv_mortalcopy(ST(1)) : 0);
	SPAGAIN;
#line 2086 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__generic__Source_allocate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__generic__Source_allocate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "clname, temple");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	clname = ST(0)
;
	SV *	temple = ST(1)
;
#line 973 "Event.xs"
	if (!SvROK(temple)) croak("Bad template");
	XPUSHs(genericsrc_2sv(pe_genericsrc_allocate(gv_stashsv(clname, 1),
			SvRV(temple))));
#line 2110 "Event.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Event__generic__Source_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__generic__Source_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    {
	SV *	ref = ST(0)
;
#line 981 "Event.xs"
{
	pe_genericsrc_dtor(sv_2genericsrc(ref));
}
#line 2130 "Event.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Event__generic__Source_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Event__generic__Source_event)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "THIS, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pe_genericsrc *	THIS = (pe_genericsrc *) sv_2genericsrc(ST(0))
;
#line 988 "Event.xs"
	pe_genericsrc_event(THIS,
		items >= 2 ? sv_mortalcopy(ST(1)) : &PL_sv_undef);
#line 2150 "Event.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Event); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Event)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Event::_add_hook", XS_Event__add_hook);
        newXS_deffile("Event::_timeout_too_early", XS_Event__timeout_too_early);
        newXS_deffile("Event::_memory_counters", XS_Event__memory_counters);
        newXS_deffile("Event::_incr_looplevel", XS_Event__incr_looplevel);
        newXS_deffile("Event::_decr_looplevel", XS_Event__decr_looplevel);
        newXS_deffile("Event::unloop", XS_Event_unloop);
        newXS_deffile("Event::unloop_all", XS_Event_unloop_all);
        newXS_deffile("Event::cache_time_api", XS_Event_cache_time_api);
        (void)newXSproto_portable("Event::time", XS_Event_time, file, "");
        (void)newXSproto_portable("Event::sleep", XS_Event_sleep, file, "$");
        newXS_deffile("Event::null_loops_per_second", XS_Event_null_loops_per_second);
        (void)newXSproto_portable("Event::all_watchers", XS_Event_all_watchers, file, "");
        (void)newXSproto_portable("Event::all_idle", XS_Event_all_idle, file, "");
        (void)newXSproto_portable("Event::all_running", XS_Event_all_running, file, "");
        (void)newXSproto_portable("Event::queue", XS_Event_queue, file, "$;$");
        (void)newXSproto_portable("Event::one_event", XS_Event_one_event, file, ";$");
        newXS_deffile("Event::_loop", XS_Event__loop);
        newXS_deffile("Event::queue_pending", XS_Event_queue_pending);
        newXS_deffile("Event::_empty_queue", XS_Event__empty_queue);
        newXS_deffile("Event::queue_time", XS_Event_queue_time);
        newXS_deffile("Event::Event::Io::got", XS_Event__Event__Io_got);
        newXS_deffile("Event::Event::Dataful::data", XS_Event__Event__Dataful_data);
        newXS_deffile("Event::Event::DESTROY", XS_Event__Event_DESTROY);
        newXS_deffile("Event::Event::mom", XS_Event__Event_mom);
        newXS_deffile("Event::Event::w", XS_Event__Event_w);
        newXS_deffile("Event::Event::hits", XS_Event__Event_hits);
        newXS_deffile("Event::Event::prio", XS_Event__Event_prio);
        newXS_deffile("Event::Watcher::DESTROY", XS_Event__Watcher_DESTROY);
        newXS_deffile("Event::Watcher::pending", XS_Event__Watcher_pending);
        newXS_deffile("Event::Watcher::again", XS_Event__Watcher_again);
        newXS_deffile("Event::Watcher::start", XS_Event__Watcher_start);
        newXS_deffile("Event::Watcher::suspend", XS_Event__Watcher_suspend);
        newXS_deffile("Event::Watcher::resume", XS_Event__Watcher_resume);
        newXS_deffile("Event::Watcher::stop", XS_Event__Watcher_stop);
        newXS_deffile("Event::Watcher::cancel", XS_Event__Watcher_cancel);
        newXS_deffile("Event::Watcher::now", XS_Event__Watcher_now);
        newXS_deffile("Event::Watcher::use_keys", XS_Event__Watcher_use_keys);
        newXS_deffile("Event::Watcher::is_running", XS_Event__Watcher_is_running);
        newXS_deffile("Event::Watcher::is_active", XS_Event__Watcher_is_active);
        newXS_deffile("Event::Watcher::is_suspended", XS_Event__Watcher_is_suspended);
        newXS_deffile("Event::Watcher::is_cancelled", XS_Event__Watcher_is_cancelled);
        newXS_deffile("Event::Watcher::cb", XS_Event__Watcher_cb);
        newXS_deffile("Event::Watcher::cbtime", XS_Event__Watcher_cbtime);
        newXS_deffile("Event::Watcher::desc", XS_Event__Watcher_desc);
        newXS_deffile("Event::Watcher::debug", XS_Event__Watcher_debug);
        newXS_deffile("Event::Watcher::prio", XS_Event__Watcher_prio);
        newXS_deffile("Event::Watcher::reentrant", XS_Event__Watcher_reentrant);
        newXS_deffile("Event::Watcher::repeat", XS_Event__Watcher_repeat);
        newXS_deffile("Event::Watcher::max_cb_tm", XS_Event__Watcher_max_cb_tm);
        newXS_deffile("Event::Watcher::Tied::allocate", XS_Event__Watcher__Tied_allocate);
        newXS_deffile("Event::Watcher::Tied::hard", XS_Event__Watcher__Tied_hard);
        newXS_deffile("Event::Watcher::Tied::at", XS_Event__Watcher__Tied_at);
        newXS_deffile("Event::Watcher::Tied::flags", XS_Event__Watcher__Tied_flags);
        newXS_deffile("Event::idle::allocate", XS_Event__idle_allocate);
        newXS_deffile("Event::idle::hard", XS_Event__idle_hard);
        newXS_deffile("Event::idle::max", XS_Event__idle_max);
        newXS_deffile("Event::idle::min", XS_Event__idle_min);
        newXS_deffile("Event::timer::allocate", XS_Event__timer_allocate);
        newXS_deffile("Event::timer::at", XS_Event__timer_at);
        newXS_deffile("Event::timer::hard", XS_Event__timer_hard);
        newXS_deffile("Event::timer::interval", XS_Event__timer_interval);
        newXS_deffile("Event::io::allocate", XS_Event__io_allocate);
        newXS_deffile("Event::io::poll", XS_Event__io_poll);
        newXS_deffile("Event::io::fd", XS_Event__io_fd);
        newXS_deffile("Event::io::timeout", XS_Event__io_timeout);
        newXS_deffile("Event::io::timeout_cb", XS_Event__io_timeout_cb);
        newXS_deffile("Event::var::allocate", XS_Event__var_allocate);
        newXS_deffile("Event::var::var", XS_Event__var_var);
        newXS_deffile("Event::var::poll", XS_Event__var_poll);
        newXS_deffile("Event::signal::allocate", XS_Event__signal_allocate);
        newXS_deffile("Event::signal::signal", XS_Event__signal_signal);
        newXS_deffile("Event::group::allocate", XS_Event__group_allocate);
        newXS_deffile("Event::group::timeout", XS_Event__group_timeout);
        newXS_deffile("Event::group::add", XS_Event__group_add);
        newXS_deffile("Event::group::del", XS_Event__group_del);
        newXS_deffile("Event::generic::allocate", XS_Event__generic_allocate);
        newXS_deffile("Event::generic::source", XS_Event__generic_source);
        newXS_deffile("Event::generic::Source::allocate", XS_Event__generic__Source_allocate);
        newXS_deffile("Event::generic::Source::DESTROY", XS_Event__generic__Source_DESTROY);
        newXS_deffile("Event::generic::Source::event", XS_Event__generic__Source_event);

    /* Initialisation Section */

#line 281 "Event.xs"
  LoopLevel = ExitLevel = 0;
  DebugLevel = SvREFCNT_inc(perl_get_sv("Event::DebugLevel", 1));
  Eval = SvREFCNT_inc(perl_get_sv("Event::Eval", 1));
  Estat.on=0;
  boot_timeable();
  boot_hook();
  boot_pe_event();
  boot_pe_watcher();
  boot_idle();
  boot_timer();
  boot_io();
  boot_devpoll();
  boot_var();
  boot_tied();
  boot_signal();
  boot_group();
  boot_generic();
  boot_queue();
  {
      SV *apisv;
      api.Ver = EventAPI_VERSION;
      api.start = pe_watcher_start;
      api.queue = queueEvent;
      api.now = pe_watcher_now;
      api.suspend = pe_watcher_suspend;
      api.resume = pe_watcher_resume;
      api.stop = pe_watcher_stop;
      api.cancel = pe_watcher_cancel;
      api.tstart = pe_timeable_start;
      api.tstop  = pe_timeable_stop;
      api.NVtime = fallback_NVtime;
      api.new_idle =   (pe_idle*  (*)(HV*,SV*))    pe_idle_allocate;
      api.new_timer =  (pe_timer* (*)(HV*,SV*))    pe_timer_allocate;
      api.new_io =     (pe_io*    (*)(HV*,SV*))    pe_io_allocate;
      api.new_var =    (pe_var*   (*)(HV*,SV*))    pe_var_allocate;
      api.new_signal = (pe_signal*(*)(HV*,SV*))    pe_signal_allocate;
      api.add_hook = capi_add_hook;
      api.cancel_hook = pe_cancel_hook;
      api.install_stats = pe_install_stats;
      api.collect_stats = pe_collect_stats;
      api.AllWatchers = &AllWatchers;
      api.watcher_2sv = watcher_2sv;
      api.sv_2watcher = sv_2watcher;
      api.event_2sv = event_2sv;
      api.sv_2event = sv_2event;
      api.unloop = pe_unloop;
      api.unloop_all = pe_unloop_all;
      api.sv_2interval = sv_2interval;
      api.events_mask_2sv = events_mask_2sv;
      api.sv_2events_mask = sv_2events_mask;

      apisv = perl_get_sv("Event::API", 1);
      sv_setiv(apisv, (IV)&api);
      SvREADONLY_on(apisv);
  }

#line 2324 "Event.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

